// LICENSE:  LGPL2.1
// Copyright (c) 2002 Tomoya Tokairin

#include <windows.h>
#include <stdio.h>
#include <vorbis/codec.h>
#include <vorbis/vorbisfile.h>
#include "oggdec.h"
#include "common.h"

//#define _CHK_CLOCK  // NbNvp

// ĐɃ[U[`̃R[obN֐ĂԊԊu̍ől(msec)
#define MAX_CALLBACK_TIME	500		

// obt@TCY
#define BUFSIZE	4*64*1024  // ef[^ǂݍݗp̃obt@(byte)̃TCY(Ƃ肠ő 4 y[W)
#define MAXPCMSAMPLESIZE	((MAX_CALLBACK_TIME*2*44100)/1000) // PCM f[^obt@̍őTv
#define MAXPCMBUFSIZE		(MAXPCMSAMPLESIZE*2) // WAVE foCXo͗pobt@̍őTv(2 ch )

// obt@֌W
LPBYTE Buffer = NULL;  // ǂݍݗpobt@
float* FtPCMbufer[2] = {NULL,NULL}; // double ^ PCM f[^obt@(E)
float* FtVol = NULL; // {[p = {32767,32767,32767,32767}
short* PCMbuffer = NULL; // PCM o͗pobt@
short* GetWaveBuffer = NULL; // oggdec_getWave() p̃obt@
DWORD DwGetWaveBufSample = 0; // GetWaveBuffer ̃Tv


// ĐԊ֌W
DWORD DwCurPos; // ݂̍Đʒu
BOOL BlPause = FALSE; // |[Yǂ
DWORD DwThreadStat = ID_THREAD_OFF;  // Xbh
HANDLE HdOggPlayThread = NULL;
double DblSeekTime;
UINT DeviceID = -1;
HANDLE HsempLock;  // bNpZ}tH
OGGINPUT_MSG_PROC LpMsgProc = NULL;
DWORD DwCallBackTime = MAX_CALLBACK_TIME; // R[obN(msec)

// Đt@C̏֌W
HANDLE HdInputOggFile = NULL;
DWORD DwPCMsize = 0; // PCM ł̃f[^
DWORD DwFileSize; 
DWORD DwTotalPage = 0; // y[W
LONG LnSerial = 0;
WAVEFORMATEX WaveFmt;


// ogg,vorbis ֌W
ogg_sync_state   o_sync; 
ogg_stream_state o_stream;
ogg_page         o_page; 
ogg_packet       o_packet;
vorbis_info      v_info; 
vorbis_comment   v_comment; 
vorbis_dsp_state v_dsp;
vorbis_block     v_block;

// vZbT֌W
DWORD dwSSE = 0;
DWORD dwSSE2 = 0;
DWORD dwMMX = 0;





//--------------------------------------------------------


DWORD WriteToSyncBuf(HANDLE hInputFile,ogg_sync_state* p_o_sync,DWORD dwReadSize);
BOOL SeekOggPage(HANDLE hInputFile,
				 DWORD dwFileSize,
				 LONG nSerial,
				 LONG nBitrate,
				 double dSeekTime,  // msec
				 WAVEFORMATEX waveFmt,
				 BYTE* buffer,DWORD dwMaxBufSize, // obt@TCY͏\傫Ƃ邱
				 LARGE_INTEGER* lpliPrePos
				 );

void SetWaveFmt(LPWAVEFORMATEX lpWaveFmt,WORD waveChn,DWORD waveRate,	WORD waveBit);

BOOL OpenWaveDevice(UINT uDeviceID,WAVEFORMATEX waveFmt,DWORD dwWaveBlockByte);
BOOL CloseWaveDevice(BOOL bForceStop);
BOOL ResetWave();
BOOL PlayWave(BYTE* lpBuffer,DWORD dwWriteByte,LPDWORD lpdwThreadStat,LPBOOL lpbPause);
	
DWORD GetOggPCMAbPos(HANDLE hInputFile,
					 DWORD dwFileSize,
					 LONG nSerial,
					 LPDWORD lpdwTotalPage,
					 BYTE* buffer,DWORD dwBufSize);

void ConvFloat2Short(float* pcmdata,
					 short* tmpBuf,
					 float* vol,
					 DWORD dwSampleNum,
					 DWORD dwOffset,
					 DWORD dwChannels,
					 DWORD dwSSE);

void GetCpuInfo(LPDWORD lpdwSSE,LPDWORD lpdwSSE2,LPDWORD lpdwMMX);
void GetCurCycle(LARGE_INTEGER* lpli);